diff -pruN 2.3.3-1/CHANGES 2.3.4-1/CHANGES
--- 2.3.3-1/CHANGES	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/CHANGES	2020-05-02 19:02:55.000000000 +0000
@@ -1,5 +1,14 @@
 Change log for confget, the configuration file variable extractor
 
+2.3.4	2020/05/02
+	- add a test for values containing a "=" character
+	- add a test for the "-P suffix" command-line option
+	- Python implementation:
+	  - fix a bug parsing values containing a "=" character
+	  - implement the "-P suffix" command-line option
+	  - setup.py: use "tests_require" instead of "test_requires"
+	  - push the source down into a src/ subdirectory
+
 2.3.3	2020/04/07
 	- Python implementation: allow the tests to be run from
 	  another directory, e.g. the confget top-level source one
diff -pruN 2.3.3-1/confget.h 2.3.4-1/confget.h
--- 2.3.3-1/confget.h	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/confget.h	2020-05-02 19:02:55.000000000 +0000
@@ -35,7 +35,7 @@
 #endif /* __GNUC__ */
 #endif /* __unused */
 
-#define VERSION_STRING	"2.3.3"
+#define VERSION_STRING	"2.3.4"
 
 typedef struct {
 	const char	* const name;
diff -pruN 2.3.3-1/debian/changelog 2.3.4-1/debian/changelog
--- 2.3.3-1/debian/changelog	2020-04-07 14:43:38.000000000 +0000
+++ 2.3.4-1/debian/changelog	2020-05-02 19:30:35.000000000 +0000
@@ -1,3 +1,14 @@
+confget (2.3.4-1) unstable; urgency=medium
+
+  * Go back to the B-D: debhelper-compat way now that dh 13 is out.
+  * Correct the upstream copyright years (add the year 2020).
+  * Drop the Name and Contact upstream metadata fields.
+  * New upstream release:
+    - refresh the python-no-executable patch
+    - adapt the test target to the moved confget Python source
+
+ -- Peter Pentchev <roam@debian.org>  Sat, 02 May 2020 22:30:35 +0300
+
 confget (2.3.3-1) unstable; urgency=medium
 
   * Temporarily disable the adequate test.
diff -pruN 2.3.3-1/debian/compat 2.3.4-1/debian/compat
--- 2.3.3-1/debian/compat	2020-04-07 14:43:38.000000000 +0000
+++ 2.3.4-1/debian/compat	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-13
diff -pruN 2.3.3-1/debian/control 2.3.4-1/debian/control
--- 2.3.3-1/debian/control	2020-04-07 14:43:38.000000000 +0000
+++ 2.3.4-1/debian/control	2020-05-02 19:30:35.000000000 +0000
@@ -3,7 +3,7 @@ Section: text
 Priority: optional
 Maintainer: Peter Pentchev <roam@debian.org>
 Build-Depends:
- debhelper (>> 12.8~),
+ debhelper-compat (= 13),
  dh-python,
  libpcre3-dev,
 Build-Depends-Indep:
diff -pruN 2.3.3-1/debian/copyright 2.3.4-1/debian/copyright
--- 2.3.3-1/debian/copyright	2020-04-07 14:43:38.000000000 +0000
+++ 2.3.4-1/debian/copyright	2020-05-02 19:30:35.000000000 +0000
@@ -5,7 +5,7 @@ Source: https://devel.ringlet.net/textpr
 License: BSD-2-clause
 
 Files: *
-Copyright: Copyright (c) 2008 - 2019  Peter Pentchev
+Copyright: Copyright (c) 2008 - 2020  Peter Pentchev
 License: BSD-2-clause
 
 Files: makedep.sh t/t1.ini t/t2.ini t/t3.ini
diff -pruN 2.3.3-1/debian/patches/python-no-executable.patch 2.3.4-1/debian/patches/python-no-executable.patch
--- 2.3.3-1/debian/patches/python-no-executable.patch	2020-04-07 14:43:38.000000000 +0000
+++ 2.3.4-1/debian/patches/python-no-executable.patch	2020-05-02 19:30:35.000000000 +0000
@@ -5,11 +5,11 @@ Last-Update: 2019-09-09
 
 --- a/python/setup.py
 +++ b/python/setup.py
-@@ -106,7 +106,6 @@
+@@ -107,7 +107,6 @@
          "Topic :: Software Development :: Libraries :: Python Modules",
          "Topic :: Utilities",
      ],
 -    entry_points={"console_scripts": ["confget=confget.__main__:main"]},
-     test_requires=[
+     tests_require=[
          'configparser;python_version<"3"',
          "ddt",
diff -pruN 2.3.3-1/debian/rules 2.3.4-1/debian/rules
--- 2.3.3-1/debian/rules	2020-04-07 14:43:38.000000000 +0000
+++ 2.3.4-1/debian/rules	2020-05-02 19:30:35.000000000 +0000
@@ -54,7 +54,7 @@ override_dh_auto_install-indep:
 	dh_auto_install --buildsystem pybuild
 
 override_dh_auto_test-indep:
-	env PYTHONPATH='${PY}' '$D/tests/tap-python.sh'
+	env PYTHONPATH='${PY}/src' '$D/tests/tap-python.sh'
 	dh_auto_test --buildsystem pybuild
 
 override_dh_installchangelogs:
diff -pruN 2.3.3-1/debian/source/lintian-overrides 2.3.4-1/debian/source/lintian-overrides
--- 2.3.3-1/debian/source/lintian-overrides	2020-04-07 14:43:38.000000000 +0000
+++ 2.3.4-1/debian/source/lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-# This package uses the experimental compat level 13.
-#
-confget source: package-needs-versioned-debhelper-build-depends 13
diff -pruN 2.3.3-1/debian/upstream/metadata 2.3.4-1/debian/upstream/metadata
--- 2.3.3-1/debian/upstream/metadata	2020-04-07 14:43:38.000000000 +0000
+++ 2.3.4-1/debian/upstream/metadata	2020-05-02 19:30:35.000000000 +0000
@@ -1,6 +1,4 @@
-Name: confget
 Bug-Submit: mailto:roam@ringlet.net
-Contact: Peter Pentchev <roam@ringlet.net>
 Security-Contact: Peter Pentchev <roam@ringlet.net>
 Repository: https://gitlab.com/confget/confget.git
 Repository-Browse: https://gitlab.com/confget/confget
diff -pruN 2.3.3-1/python/confget/backend/abstract.py 2.3.4-1/python/confget/backend/abstract.py
--- 2.3.3-1/python/confget/backend/abstract.py	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/python/confget/backend/abstract.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,68 +0,0 @@
-# Copyright (c) 2018 - 2020  Peter Pentchev <roam@ringlet.net>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-
-"""An abstract metaclass for confget backends."""
-
-import abc
-import configparser
-
-import six
-
-from .. import defs
-
-try:
-    from typing import Dict, Text  # noqa: H301
-
-    _TYPING_USED = (defs, Dict, Text)
-except ImportError:
-    pass
-
-
-@six.add_metaclass(abc.ABCMeta)
-class Backend(object):
-    # pylint: disable=too-few-public-methods
-    """An abstract confget parser backend."""
-
-    def __init__(self, cfg):
-        # type: (Backend, defs.Config) -> None
-        self._cfg = cfg
-
-    @abc.abstractmethod
-    def read_file(self):
-        # type: (Backend) -> defs.ConfigData
-        """Read and parse the configuration file, invoke the callbacks."""
-        raise NotImplementedError("Backend.read_file")
-
-    @abc.abstractmethod
-    def get_dict(self):
-        # type: (Backend) -> defs.ConfigData
-        """Return the sections and values from the configuration file."""
-        raise NotImplementedError("Backend.get_dict")
-
-    def get_configparser(self):
-        # type: (Backend) -> configparser.ConfigParser
-        """Return a ConfigParser object with the parsed values."""
-        par = configparser.ConfigParser(interpolation=None)
-        par.read_dict(self.get_dict())
-        return par
diff -pruN 2.3.3-1/python/confget/backend/http_get.py 2.3.4-1/python/confget/backend/http_get.py
--- 2.3.3-1/python/confget/backend/http_get.py	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/python/confget/backend/http_get.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,117 +0,0 @@
-# Copyright (c) 2018 - 2020  Peter Pentchev <roam@ringlet.net>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-
-"""A confget backend for reading INI-style files."""
-
-import os
-import re
-import sys
-
-from .. import defs
-
-from . import abstract
-
-try:
-    from typing import Dict, List  # noqa: H301
-
-    _TYPING_USED = (defs, Dict, List)
-except ImportError:
-    pass
-
-if sys.version_info[0] < 3:
-    import urllib as uparse
-else:
-    import urllib.parse as uparse
-
-
-RE_ENTITY = re.compile(r"^ (?P<full> [a-zA-Z0-9_]+ ; )", re.X)
-
-
-class HTTPGetBackend(abstract.Backend):
-    # pylint: disable=too-few-public-methods
-    """Parse INI-style configuration files."""
-
-    def __init__(self, cfg):
-        # type: (HTTPGetBackend, defs.Config) -> None
-        super(HTTPGetBackend, self).__init__(cfg)
-
-        if self._cfg.filename is not None:
-            raise ValueError("No config filename expected")
-
-        qname = (
-            "QUERY_STRING" if self._cfg.section == "" else self._cfg.section
-        )
-        qval = os.environ.get(qname, None)
-        if qval is None:
-            raise ValueError(
-                'No "{qname}" variable in the environment'.format(qname=qname)
-            )
-        self.query_string = qval
-        self.parsed = {}  # type: defs.ConfigData
-
-    def read_file(self):
-        # type: (HTTPGetBackend) -> defs.ConfigData
-        def split_by_amp(line):
-            # type: (str) -> List[str]
-            """Split a line by "&" or "&amp;" tokens."""
-            if not line:
-                return []
-
-            start = end = 0
-            while True:
-                pos = line[start:].find("&")
-                if pos == -1:
-                    return [line]
-                if line[pos + 1 :].startswith("amp;"):
-                    end = pos + 4
-                    break
-                entity = RE_ENTITY.match(line[pos + 1 :])
-                if entity is None:
-                    end = pos
-                    break
-                start = pos + len(entity.group("full"))
-
-            return [line[:pos]] + split_by_amp(line[end + 1 :])
-
-        data = {}  # type: Dict[str, str]
-        fragments = split_by_amp(self.query_string)
-        for varval in fragments:
-            fields = varval.split("=")
-            if len(fields) == 1:
-                fields.append("")
-            elif len(fields) != 2:
-                raise ValueError(
-                    'Invalid query string component: "{varval}"'.format(
-                        varval=varval
-                    )
-                )
-            data[uparse.unquote(fields[0])] = uparse.unquote(fields[1])
-
-        self.parsed = {self._cfg.section: data}
-        return self.get_dict()
-
-    def get_dict(self):
-        # type: (HTTPGetBackend) -> defs.ConfigData
-        # no dict comprehension, this ought to work on Python 2.6, too
-        return dict((item[0], dict(item[1])) for item in self.parsed.items())
diff -pruN 2.3.3-1/python/confget/backend/ini.py 2.3.4-1/python/confget/backend/ini.py
--- 2.3.3-1/python/confget/backend/ini.py	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/python/confget/backend/ini.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,191 +0,0 @@
-# Copyright (c) 2018 - 2020  Peter Pentchev <roam@ringlet.net>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-
-"""A confget backend for reading INI-style files."""
-
-import io
-import re
-import sys
-
-from .. import defs
-
-from . import abstract
-
-try:
-    from typing import Callable, Dict, Match, NamedTuple, Pattern  # noqa: H301
-
-    _TYPING_USED = (defs, Dict)
-
-    MatcherType = NamedTuple(
-        "MatcherType",
-        [
-            ("regex", Pattern[str]),
-            (
-                "handle",
-                Callable[
-                    [Match[str], Dict[str, str], defs.Config, defs.ConfigData],
-                    None,
-                ],
-            ),
-        ],
-    )
-except ImportError:
-    import collections
-
-    MatcherType = collections.namedtuple(  # type: ignore
-        "MatcherType", ["regex", "handle"]
-    )
-
-
-class INIBackend(abstract.Backend):
-    # pylint: disable=too-few-public-methods
-    """Parse INI-style configuration files."""
-
-    def __init__(self, cfg, encoding="UTF-8"):
-        # type: (INIBackend, defs.Config, str) -> None
-        super(INIBackend, self).__init__(cfg)
-
-        if self._cfg.filename is None:
-            raise ValueError("No config filename specified")
-        if self._cfg.filename == "-":
-            infile = io.open(sys.stdin.fileno(), mode="r", encoding=encoding)
-        else:
-            infile = io.open(self._cfg.filename, mode="r", encoding=encoding)
-        self.infile = infile
-        self.parsed = {}  # type: defs.ConfigData
-
-    def read_file(self):
-        # type: (INIBackend) -> defs.ConfigData
-        state = {
-            "section": "",
-            "name": "",
-            "value": "",
-            "cont": "",
-            "found": "",
-        }
-        res = {"": {}}  # type: defs.ConfigData
-
-        def handle_section(
-            match,  # type: Match[str]
-            state,  # type: Dict[str, str]
-            cfg,  # type: defs.Config
-            res,  # type: defs.ConfigData
-        ):  # type: (...) -> None
-            """Handle a section heading: store the name."""
-            state["section"] = match.group("name")
-            if state["section"] not in res:
-                res[state["section"]] = {}
-            if not (cfg.section_specified or cfg.section or state["found"]):
-                cfg.section = state["section"]
-            state["found"] = state["section"]
-
-        def handle_comment(
-            _match,  # type: Match[str]
-            _state,  # type: Dict[str, str]
-            _cfg,  # type: defs.Config
-            _res,  # type: defs.ConfigData
-        ):  # type: (...) -> None
-            """Handle a comment line: ignore it."""
-            pass  # pylint: disable=unnecessary-pass
-
-        def handle_variable(
-            match,  # type: Match[str]
-            state,  # type: Dict[str, str]
-            _cfg,  # type: defs.Config
-            res,  # type: defs.ConfigData
-        ):  # type: (...) -> None
-            """Handle an assignment: store, check for a continuation."""
-            state["name"] = match.group("name")
-            state["value"] = match.group("value")
-            state["cont"] = match.group("cont")
-            state["found"] = state["name"]
-            if not state["cont"]:
-                res[state["section"]][state["name"]] = state["value"]
-
-        matches = [
-            MatcherType(
-                regex=re.compile(r"^ \s* (?: [#;] .* )? $", re.X),
-                handle=handle_comment,
-            ),
-            MatcherType(
-                regex=re.compile(
-                    r"""
-                    ^
-                    \s* \[ \s*
-                    (?P<name> [^\]]+? )
-                    \s* \] \s*
-                    $""",
-                    re.X,
-                ),
-                handle=handle_section,
-            ),
-            MatcherType(
-                regex=re.compile(
-                    r"""
-                    ^
-                    \s*
-                    (?P<name> \S+ )
-                    \s* = \s*
-                    (?P<value> .*? )
-                    \s*
-                    (?P<cont> [\\] )?
-                    $""",
-                    re.X,
-                ),
-                handle=handle_variable,
-            ),
-        ]
-
-        for line in self.infile.readlines():
-            line = line.rstrip("\r\n")
-            if state["cont"]:
-                if line.endswith("\\"):
-                    line, state["cont"] = line[:-1], line[-1]
-                else:
-                    state["cont"] = ""
-                state["value"] += line
-                if not state["cont"]:
-                    res[state["section"]][state["name"]] = state["value"]
-                continue
-
-            for data in matches:
-                match = data.regex.match(line)
-                if match is None:
-                    continue
-                data.handle(match, state, self._cfg, res)
-                break
-            else:
-                raise ValueError(
-                    "Unexpected line in {fname}: {line}".format(
-                        fname=self._cfg.filename, line=line
-                    )
-                )
-
-        self.parsed = res
-        return self.get_dict()
-
-    def get_dict(self):
-        # type: (INIBackend) -> defs.ConfigData
-        # no dict comprehension, this ought to work on Python 2.6, too
-        return dict((item[0], dict(item[1])) for item in self.parsed.items())
diff -pruN 2.3.3-1/python/confget/backend/__init__.py 2.3.4-1/python/confget/backend/__init__.py
--- 2.3.3-1/python/confget/backend/__init__.py	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/python/confget/backend/__init__.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,42 +0,0 @@
-# Copyright (c) 2018 - 2020  Peter Pentchev <roam@ringlet.net>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-
-"""Provide an interface to all the configuration format backends."""
-
-from . import abstract
-from . import http_get
-from . import ini
-
-try:
-    from typing import Dict, Type  # noqa: H301
-
-    _TYPING_USED = (Dict, Type, abstract)
-except ImportError:
-    pass
-
-
-BACKENDS = {
-    "http_get": http_get.HTTPGetBackend,
-    "ini": ini.INIBackend,
-}  # type: Dict[str, Type[abstract.Backend]]
diff -pruN 2.3.3-1/python/confget/defs.py 2.3.4-1/python/confget/defs.py
--- 2.3.3-1/python/confget/defs.py	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/python/confget/defs.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,56 +0,0 @@
-# Copyright (c) 2018 - 2020  Peter Pentchev <roam@ringlet.net>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-
-"""Common definitions for the confget configuration parsing library."""
-
-try:
-    from typing import Dict, List, Optional  # noqa: H301
-
-    _TYPING_USED = (List, Optional)
-
-    ConfigData = Dict[str, Dict[str, str]]
-except ImportError:
-    pass
-
-
-VERSION_STRING = "2.3.3"
-FEATURES = [("BASE", VERSION_STRING)]
-
-
-class Config(object):
-    # pylint: disable=too-few-public-methods
-    """Base class for the internal confget configuration."""
-
-    def __init__(
-        self,  # type: Config
-        varnames,  # type: List[str]
-        filename=None,  # type: Optional[str]
-        section="",  # type: str
-        section_specified=False,  # type: bool
-    ):  # type: (...) -> None
-        """Store the specified configuration values."""
-        self.filename = filename
-        self.section = section
-        self.section_specified = section_specified
-        self.varnames = varnames
diff -pruN 2.3.3-1/python/confget/format.py 2.3.4-1/python/confget/format.py
--- 2.3.3-1/python/confget/format.py	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/python/confget/format.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,233 +0,0 @@
-# Copyright (c) 2018 - 2020  Peter Pentchev <roam@ringlet.net>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-
-"""Filter and format a subset of the configuration variables."""
-
-import fnmatch
-import re
-
-try:
-    from typing import (
-        Callable,
-        Dict,
-        Iterable,
-        NamedTuple,
-        List,
-        Optional,
-    )  # noqa: H301
-
-    _TYPING_USED = (Callable, Dict, Iterable, List, Optional)
-
-    FormatOutput = NamedTuple(
-        "FormatOutput",
-        [
-            ("name", str),
-            ("value", str),
-            ("output_name", str),
-            ("output_value", str),
-            ("output_full", str),
-        ],
-    )
-except ImportError:
-    import collections
-
-    FormatOutput = collections.namedtuple(  # type: ignore
-        "FormatOutput",
-        ["name", "value", "output_name", "output_value", "output_full"],
-    )
-
-from . import defs
-
-
-class FormatConfig(defs.Config):
-    # pylint: disable=too-few-public-methods,too-many-instance-attributes
-    """Extend the config class with some output settings.
-
-    Add the following settings:
-    - list_all (boolean): list all variables, not just a subset
-    - match_regex (boolean): for match_var_names and match_var_values,
-      perform regular expression matches instead of filename pattern ones
-    - match_var_names (boolean): treat the variable names specified as
-      patterns and display all variables that match those
-    - match_var_values (string): display only the variables with values
-      that match this pattern
-    - name_prefix (string): when displaying variable names, prefix them
-      with this string
-    - show_var_name (boolean): display the variable names, not just
-      the values
-    - shell_escape (boolean): format the values in a manner suitable for
-      the Bourne shell
-    """
-
-    def __init__(
-        self,  # type: FormatConfig
-        varnames,  # type: List[str]
-        filename=None,  # type: Optional[str]
-        list_all=False,  # type: bool
-        match_regex=False,  # type: bool
-        match_var_names=False,  # type: bool
-        match_var_values=None,  # type: Optional[str]
-        name_prefix=None,  # type: Optional[str]
-        section="",  # type: str
-        section_override=False,  # type: bool
-        section_specified=False,  # type: bool
-        show_var_name=False,  # type: bool
-        shell_escape=False,  # type: bool
-    ):  # type: (...) -> None
-        # pylint: disable=too-many-arguments
-        """Store the specified configuration values."""
-        super(FormatConfig, self).__init__(
-            filename=filename,
-            section=section,
-            section_specified=section_specified,
-            varnames=varnames,
-        )
-        self.list_all = list_all
-        self.match_regex = match_regex
-        self.match_var_names = match_var_names
-        self.match_var_values = match_var_values
-        self.name_prefix = name_prefix
-        self.section_override = section_override
-        self.shell_escape = shell_escape
-        self.show_var_name = show_var_name
-
-    def __repr__(self):
-        # type: (FormatConfig) -> str
-        return "{tname}({varnames}, {attrs})".format(
-            tname=type(self).__name__,
-            varnames=repr(self.varnames),
-            attrs=", ".join(
-                [
-                    "{name}={value}".format(
-                        name=name, value=repr(getattr(self, name))
-                    )
-                    for name in [
-                        "filename",
-                        "list_all",
-                        "match_regex",
-                        "match_var_names",
-                        "match_var_values",
-                        "name_prefix",
-                        "section",
-                        "section_override",
-                        "section_specified",
-                        "show_var_name",
-                        "shell_escape",
-                    ]
-                ]
-            ),
-        )
-
-
-def get_check_function(cfg, patterns):
-    # type: (FormatConfig, List[str]) -> Callable[[str], bool]
-    """Get a predicate for displayed variables.
-
-    Get a function that determines whether a variable name should be
-    included in the displayed subset.
-    """
-    if cfg.match_regex:
-        re_vars = [re.compile(name) for name in patterns]
-
-        def check_re_vars(key):
-            # type: (str) -> bool
-            """Check that the key matches any of the specified regexes."""
-            return any(rex.search(key) for rex in re_vars)
-
-        return check_re_vars
-
-    def check_fn_vars(key):
-        # type: (str) -> bool
-        """Check that the key matches any of the specified patterns."""
-        return any(fnmatch.fnmatch(key, pattern) for pattern in patterns)
-
-    return check_fn_vars
-
-
-def get_varnames(cfg, sect_data):
-    # type: (FormatConfig, Dict[str, str]) -> Iterable[str]
-    """Get the variable names that match the configuration requirements."""
-    if cfg.list_all:
-        varnames = sect_data.keys()  # type: Iterable[str]
-    elif cfg.match_var_names:
-        check_var = get_check_function(cfg, cfg.varnames)
-        varnames = [name for name in sect_data.keys() if check_var(name)]
-    else:
-        varnames = [name for name in cfg.varnames if name in sect_data]
-
-    if not cfg.match_var_values:
-        return varnames
-
-    check_value = get_check_function(cfg, [cfg.match_var_values])
-    return [name for name in varnames if check_value(sect_data[name])]
-
-
-def filter_vars(cfg, data):
-    # type: (FormatConfig, defs.ConfigData) -> Iterable[FormatOutput]
-    """Filter the variables according to the specified criteria.
-
-    Return an iterable of FormatOutput structures allowing the caller to
-    process the variable names and values in various ways.
-    """
-    if cfg.section_override:
-        sect_data = data[""]
-    else:
-        sect_data = {}
-    if cfg.section in data:
-        sect_data.update(data[cfg.section])
-
-    varnames = get_varnames(cfg, sect_data)
-    res = []  # type: List[FormatOutput]
-    for name in sorted(varnames):
-        if cfg.name_prefix:
-            output_name = cfg.name_prefix + name
-        else:
-            output_name = name
-
-        value = sect_data[name]
-        if cfg.shell_escape:
-            output_value = "'{esc}'".format(
-                esc="'\"'\"'".join(value.split("'"))
-            )
-        else:
-            output_value = value
-
-        if cfg.show_var_name:
-            output_full = "{name}={value}".format(
-                name=output_name, value=output_value
-            )
-        else:
-            output_full = output_value
-
-        res.append(
-            FormatOutput(
-                name=name,
-                value=value,
-                output_name=output_name,
-                output_value=output_value,
-                output_full=output_full,
-            )
-        )
-
-    return res
diff -pruN 2.3.3-1/python/confget/__init__.py 2.3.4-1/python/confget/__init__.py
--- 2.3.3-1/python/confget/__init__.py	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/python/confget/__init__.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,108 +0,0 @@
-# Copyright (c) 2019, 2020  Peter Pentchev <roam@ringlet.net>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-
-"""confget - a library for parsing configuration files
-
-The `confget` library parses configuration files (currently INI-style
-files and CGI `QUERY_STRING` environment variable) and allows a program
-to use the values defined in them.  It provides various options for
-selecting the variable names and values to return and the configuration
-file sections to fetch them from.
-
-The `confget` library may also be used as a command-line tool with
-the same interface as the C implementation.
-
-The `confget` library is fully typed.
-
-Specifying configuration values for the backends
-------------------------------------------------
-
-The `confget.defs` module defines the `Config` class that is used to
-control the behavior of the various `confget` backends.  Its main
-purpose is to specify the filename and, optionally, the section name for
-INI-style files, but other backends may use its fields in different ways.
-
-A `Config` object is created using the following parameters:
-- a list of variable names to query (may be empty)
-- `filename` (str, optional): the name of the file to open
-- `section` (str, default ""): the name of the section within the file
-- `section_specified` (bool, default false): if `section` is an empty
-  string, only fetch variables from the unnamed section at the start of
-  the file instead of defaulting to the first section in the file
-
-Parsing INI-style configuration files
--------------------------------------
-
-The `confget` library's "ini" backend parses an INI-style configuration
-file.  Its `read_file()` method parses the file and returns a dictionary
-of sections and the variables and their values within them:
-
-    import confget
-
-    cfg = confget.Config([], filename='config.ini')
-    ini = confget.BACKENDS['ini'](cfg)
-    data = ini.read_file()
-    print('Section names: {names}'.format(names=sorted(data.keys())))
-    print(data['server']['address'])
-
-Letting variables in a section override the default ones
---------------------------------------------------------
-
-In some cases it is useful to have default values before the first
-named section in a file and then override some values in various
-sections.  This may be useful for e.g. host-specific configuration
-kept in a section with the same name as the host.
-
-The `format` module in the `confget` library allows, among other
-filtering modes, to get the list of variables with a section
-overriding the default ones:
-
-    from confget import backend, format
-
-    cfg = format.FormatConfig(['foo'], filename='config.ini', section='first',
-                              section_override=True)
-    ini = backend.BACKENDS['ini'](cfg)
-    data = ini.read_file()
-    res = format.filter_vars(cfg, data)
-    assert len(res) == 1, repr(res)
-    print(res[0].output_full)
-
-    cfg = format.FormatConfig(['foo'], filename='config.ini', section='second',
-                              section_override=True)
-    ini = backend.BACKENDS['ini'](cfg)
-    data = ini.read_file()
-    res = format.filter_vars(cfg, data)
-    assert len(res) == 1, repr(res)
-    print(res[0].output_full)
-
-See the documentation of the `FormatConfig` class and the `filter_vars()`
-function in the `confget.format` module for more information and for
-a list of the various other filtering modes, all supported when
-the library is used as a command-line tool.
-"""
-
-from .defs import Config, VERSION_STRING  # noqa: H301
-from .backend import BACKENDS
-
-__all__ = ("BACKENDS", "Config", "VERSION_STRING")
diff -pruN 2.3.3-1/python/confget/__main__.py 2.3.4-1/python/confget/__main__.py
--- 2.3.3-1/python/confget/__main__.py	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/python/confget/__main__.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,369 +0,0 @@
-# Copyright (c) 2018 - 2020  Peter Pentchev
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-
-"""The command-line interface to the confget module: specify some parameters
-through command-line options, then display variable values or names.
-"""
-
-from __future__ import print_function
-
-import argparse
-import sys
-
-from . import backend
-from . import defs
-from . import format as fmt
-
-try:
-    from typing import List, Optional  # noqa: H301
-
-    _TYPING_USED = (defs, List, Optional)
-except ImportError:
-    pass
-
-
-class MainConfig(fmt.FormatConfig):
-    # pylint: disable=too-few-public-methods,too-many-instance-attributes
-    """Extend the format config class with some output settings.
-
-    Add the following settings:
-    - check_only (boolean): only check whether a variable is defined
-    - query_sections (boolean): only display the section names
-    """
-
-    def __init__(
-        self,  # type: MainConfig
-        check_only,  # type: bool
-        filename,  # type: Optional[str]
-        list_all,  # type: bool
-        match_regex,  # type: bool
-        match_var_names,  # type: bool
-        match_var_values,  # type: Optional[str]
-        name_prefix,  # type: Optional[str]
-        query_sections,  # type: bool
-        section,  # type: str
-        section_override,  # type: bool
-        section_specified,  # type: bool
-        show_var_name,  # type: bool
-        shell_escape,  # type: bool
-        varnames,  # type: List[str]
-    ):  # type: (...) -> None
-        # pylint: disable=too-many-arguments,too-many-locals
-        """Store the specified configuration values."""
-        super(MainConfig, self).__init__(
-            filename=filename,
-            list_all=list_all,
-            match_regex=match_regex,
-            match_var_names=match_var_names,
-            match_var_values=match_var_values,
-            name_prefix=name_prefix,
-            section=section,
-            section_specified=section_specified,
-            section_override=section_override,
-            show_var_name=show_var_name,
-            shell_escape=shell_escape,
-            varnames=varnames,
-        )
-        self.check_only = check_only
-        self.query_sections = query_sections
-
-
-def version():
-    # type: () -> None
-    """Display program version information."""
-    print("confget " + defs.VERSION_STRING)
-
-
-def features(name):
-    # type: (Optional[str]) -> None
-    """Display a list of the features supported by the program."""
-    if name is None:
-        print(
-            " ".join(
-                [
-                    "{name}={version}".format(name=item[0], version=item[1])
-                    for item in defs.FEATURES
-                ]
-            )
-        )
-    else:
-        ver = dict(defs.FEATURES).get(name, None)
-        if ver is None:
-            sys.exit(1)
-        print(ver)
-
-
-def output_check_only(cfg, data):
-    # type: (MainConfig, defs.ConfigData) -> None
-    """Check whether the variable is present."""
-    if cfg.section not in data:
-        sys.exit(1)
-    elif cfg.varnames[0] not in data[cfg.section]:
-        sys.exit(1)
-    sys.exit(0)
-
-
-def output_vars(cfg, data):
-    # type: (MainConfig, defs.ConfigData) -> None
-    """Output the variable values."""
-    for vitem in fmt.filter_vars(cfg, data):
-        print(vitem.output_full)
-
-
-def output_sections(data):
-    # type: (defs.ConfigData) -> None
-    """Output the section names."""
-    for name in sorted(data.keys()):
-        if name != "":
-            print(name)
-
-
-def validate_options(args, backend_name):
-    # type: (argparse.Namespace, str) -> None
-    """Detect invalid combinations of command-line options."""
-    query_sections = args.query == "sections"
-
-    if args.list_all or query_sections:
-        if args.varnames:
-            sys.exit("Only a single query at a time, please!")
-    elif args.match_var_names:
-        if not args.varnames:
-            sys.exit("No patterns to match against")
-    elif args.check_only and len(args.varnames) > 1:
-        sys.exit("Only a single query at a time, please!")
-    elif not args.varnames:
-        sys.exit("No variables specified to query")
-
-    if query_sections and backend_name != "ini":
-        sys.exit(
-            "The query for sections is only supported for "
-            "the 'ini' backend for the present"
-        )
-
-
-def check_option_conflicts(args):
-    # type: (argparse.Namespace) -> None
-    """Make sure that the command-line options do not conflict."""
-    total = (
-        int(args.query is not None)
-        + int(args.match_var_names)
-        + int(args.list_all)
-        + int(
-            bool(args.varnames)
-            and not (args.match_var_names or args.query == "feature")
-        )
-    )
-    if total > 1:
-        sys.exit("Only a single query at a time, please!")
-
-
-def main():
-    # type: () -> None
-    """The main program: parse arguments, do things."""
-    parser = argparse.ArgumentParser(
-        prog="confget",
-        usage="""
-    confget [-t ini] -f filename [-s section] varname...
-    confget -V | -h | --help | --version
-    confget -q features""",
-    )
-    parser.add_argument(
-        "-c",
-        action="store_true",
-        dest="check_only",
-        help="check whether the variables are defined in " "the file",
-    )
-    parser.add_argument(
-        "-f",
-        type=str,
-        dest="filename",
-        help="specify the configuration file name",
-    )
-    parser.add_argument(
-        "-L",
-        action="store_true",
-        dest="match_var_names",
-        help="specify which variables to display",
-    )
-    parser.add_argument(
-        "-l",
-        action="store_true",
-        dest="list_all",
-        help="list all variables in the specified section",
-    )
-    parser.add_argument(
-        "-m",
-        type=str,
-        dest="match_var_values",
-        help="only display variables with values that match "
-        "the specified pattern",
-    )
-    parser.add_argument(
-        "-N",
-        action="store_true",
-        dest="show_var_name",
-        help="always display the variable name",
-    )
-    parser.add_argument(
-        "-n",
-        action="store_true",
-        dest="hide_var_name",
-        help="never display the variable name",
-    )
-    parser.add_argument(
-        "-O",
-        action="store_true",
-        dest="section_override",
-        help="allow variables in the specified section to "
-        "override those placed before any "
-        "section definitions",
-    )
-    parser.add_argument(
-        "-p",
-        type=str,
-        dest="name_prefix",
-        help="display this string before the variable name",
-    )
-    parser.add_argument(
-        "-q",
-        type=str,
-        dest="query",
-        choices=["feature", "features", "sections"],
-        help="query for a specific type of information, e.g. the list of "
-        "sections defined in "
-        "the configuration file",
-    )
-    parser.add_argument(
-        "-S",
-        action="store_true",
-        dest="shell_quote",
-        help="quote the values suitably for the Bourne shell",
-    )
-    parser.add_argument(
-        "-s",
-        type=str,
-        dest="section",
-        help="specify the configuration file section",
-    )
-    parser.add_argument(
-        "-t",
-        type=str,
-        default="ini",
-        dest="backend",
-        help="specify the configuration file type",
-    )
-    parser.add_argument(
-        "-V",
-        "--version",
-        action="store_true",
-        help="display program version information and exit",
-    )
-    parser.add_argument(
-        "-x",
-        action="store_true",
-        dest="match_regex",
-        help="treat the match patterns as regular expressions",
-    )
-    parser.add_argument(
-        "varnames", nargs="*", help="the variable names to query"
-    )
-
-    args = parser.parse_args()
-    if args.version:
-        version()
-        return
-
-    check_option_conflicts(args)
-
-    if args.query == "features":
-        if args.varnames:
-            sys.exit("No arguments to -q features")
-        features(None)
-        return
-    if args.query == "feature":
-        if len(args.varnames) != 1:
-            sys.exit("Only a single feature name expected")
-        features(args.varnames[0])
-        return
-
-    query_sections = args.query == "sections"
-
-    cfg = MainConfig(
-        check_only=args.check_only,
-        filename=args.filename,
-        list_all=args.list_all,
-        match_regex=args.match_regex,
-        match_var_names=args.match_var_names,
-        match_var_values=args.match_var_values,
-        name_prefix=args.name_prefix,
-        query_sections=query_sections,
-        section=args.section if args.section is not None else "",
-        section_override=args.section_override,
-        section_specified=args.section is not None,
-        shell_escape=args.shell_quote,
-        show_var_name=args.show_var_name
-        or (
-            (args.match_var_names or args.list_all or len(args.varnames) > 1)
-            and not args.hide_var_name
-        ),
-        varnames=args.varnames,
-    )
-
-    matched_backends = [
-        name
-        for name in sorted(backend.BACKENDS.keys())
-        if name.startswith(args.backend)
-    ]
-    if not matched_backends:
-        sys.exit(
-            'Unknown backend "{name}", use "list" for a list'.format(
-                name=args.backend
-            )
-        )
-    elif len(matched_backends) > 1:
-        sys.exit(
-            'Ambiguous backend "{name}": {lst}'.format(
-                name=args.backend, lst=" ".join(matched_backends)
-            )
-        )
-    back = backend.BACKENDS[matched_backends[0]]
-
-    validate_options(args, matched_backends[0])
-
-    try:
-        cfgp = back(cfg)
-    except Exception as exc:  # pylint: disable=broad-except
-        sys.exit(str(exc))
-    data = cfgp.read_file()
-
-    if cfg.check_only:
-        output_check_only(cfg, data)
-    elif query_sections:
-        output_sections(data)
-    else:
-        output_vars(cfg, data)
-
-
-if __name__ == "__main__":
-    main()
diff -pruN 2.3.3-1/python/setup.py 2.3.4-1/python/setup.py
--- 2.3.3-1/python/setup.py	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/python/setup.py	2020-05-02 19:02:55.000000000 +0000
@@ -47,7 +47,7 @@ def get_version():
     """Get the version string from the module's __init__ file."""
     found = None
     re_semver = re.compile(RE_VERSION, re.X)
-    with open("confget/defs.py") as init:
+    with open("src/confget/defs.py") as init:
         for line in init.readlines():
             match = re_semver.match(line)
             if not match:
@@ -76,6 +76,7 @@ setuptools.setup(
     author_email="roam@ringlet.net",
     url="https://devel.ringlet.net/textproc/confget/",
     packages=["confget", "confget.backend"],
+    package_dir={"": "src"},
     package_data={
         "confget": [
             # The typed module marker
@@ -107,7 +108,7 @@ setuptools.setup(
         "Topic :: Utilities",
     ],
     entry_points={"console_scripts": ["confget=confget.__main__:main"]},
-    test_requires=[
+    tests_require=[
         'configparser;python_version<"3"',
         "ddt",
         'pathlib2;python_version<"3"',
diff -pruN 2.3.3-1/python/src/confget/backend/abstract.py 2.3.4-1/python/src/confget/backend/abstract.py
--- 2.3.3-1/python/src/confget/backend/abstract.py	1970-01-01 00:00:00.000000000 +0000
+++ 2.3.4-1/python/src/confget/backend/abstract.py	2020-05-02 19:02:55.000000000 +0000
@@ -0,0 +1,68 @@
+# Copyright (c) 2018 - 2020  Peter Pentchev <roam@ringlet.net>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+"""An abstract metaclass for confget backends."""
+
+import abc
+import configparser
+
+import six
+
+from .. import defs
+
+try:
+    from typing import Dict, Text  # noqa: H301
+
+    _TYPING_USED = (defs, Dict, Text)
+except ImportError:
+    pass
+
+
+@six.add_metaclass(abc.ABCMeta)
+class Backend(object):
+    # pylint: disable=too-few-public-methods
+    """An abstract confget parser backend."""
+
+    def __init__(self, cfg):
+        # type: (Backend, defs.Config) -> None
+        self._cfg = cfg
+
+    @abc.abstractmethod
+    def read_file(self):
+        # type: (Backend) -> defs.ConfigData
+        """Read and parse the configuration file, invoke the callbacks."""
+        raise NotImplementedError("Backend.read_file")
+
+    @abc.abstractmethod
+    def get_dict(self):
+        # type: (Backend) -> defs.ConfigData
+        """Return the sections and values from the configuration file."""
+        raise NotImplementedError("Backend.get_dict")
+
+    def get_configparser(self):
+        # type: (Backend) -> configparser.ConfigParser
+        """Return a ConfigParser object with the parsed values."""
+        par = configparser.ConfigParser(interpolation=None)
+        par.read_dict(self.get_dict())
+        return par
diff -pruN 2.3.3-1/python/src/confget/backend/http_get.py 2.3.4-1/python/src/confget/backend/http_get.py
--- 2.3.3-1/python/src/confget/backend/http_get.py	1970-01-01 00:00:00.000000000 +0000
+++ 2.3.4-1/python/src/confget/backend/http_get.py	2020-05-02 19:02:55.000000000 +0000
@@ -0,0 +1,117 @@
+# Copyright (c) 2018 - 2020  Peter Pentchev <roam@ringlet.net>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+"""A confget backend for reading INI-style files."""
+
+import os
+import re
+import sys
+
+from .. import defs
+
+from . import abstract
+
+try:
+    from typing import Dict, List  # noqa: H301
+
+    _TYPING_USED = (defs, Dict, List)
+except ImportError:
+    pass
+
+if sys.version_info[0] < 3:
+    import urllib as uparse
+else:
+    import urllib.parse as uparse
+
+
+RE_ENTITY = re.compile(r"^ (?P<full> [a-zA-Z0-9_]+ ; )", re.X)
+
+
+class HTTPGetBackend(abstract.Backend):
+    # pylint: disable=too-few-public-methods
+    """Parse INI-style configuration files."""
+
+    def __init__(self, cfg):
+        # type: (HTTPGetBackend, defs.Config) -> None
+        super(HTTPGetBackend, self).__init__(cfg)
+
+        if self._cfg.filename is not None:
+            raise ValueError("No config filename expected")
+
+        qname = (
+            "QUERY_STRING" if self._cfg.section == "" else self._cfg.section
+        )
+        qval = os.environ.get(qname, None)
+        if qval is None:
+            raise ValueError(
+                'No "{qname}" variable in the environment'.format(qname=qname)
+            )
+        self.query_string = qval
+        self.parsed = {}  # type: defs.ConfigData
+
+    def read_file(self):
+        # type: (HTTPGetBackend) -> defs.ConfigData
+        def split_by_amp(line):
+            # type: (str) -> List[str]
+            """Split a line by "&" or "&amp;" tokens."""
+            if not line:
+                return []
+
+            start = end = 0
+            while True:
+                pos = line[start:].find("&")
+                if pos == -1:
+                    return [line]
+                if line[pos + 1 :].startswith("amp;"):
+                    end = pos + 4
+                    break
+                entity = RE_ENTITY.match(line[pos + 1 :])
+                if entity is None:
+                    end = pos
+                    break
+                start = pos + len(entity.group("full"))
+
+            return [line[:pos]] + split_by_amp(line[end + 1 :])
+
+        data = {}  # type: Dict[str, str]
+        fragments = split_by_amp(self.query_string)
+        for varval in fragments:
+            fields = varval.split("=")
+            if len(fields) == 1:
+                fields.append("")
+            elif len(fields) != 2:
+                raise ValueError(
+                    'Invalid query string component: "{varval}"'.format(
+                        varval=varval
+                    )
+                )
+            data[uparse.unquote(fields[0])] = uparse.unquote(fields[1])
+
+        self.parsed = {self._cfg.section: data}
+        return self.get_dict()
+
+    def get_dict(self):
+        # type: (HTTPGetBackend) -> defs.ConfigData
+        # no dict comprehension, this ought to work on Python 2.6, too
+        return dict((item[0], dict(item[1])) for item in self.parsed.items())
diff -pruN 2.3.3-1/python/src/confget/backend/ini.py 2.3.4-1/python/src/confget/backend/ini.py
--- 2.3.3-1/python/src/confget/backend/ini.py	1970-01-01 00:00:00.000000000 +0000
+++ 2.3.4-1/python/src/confget/backend/ini.py	2020-05-02 19:02:55.000000000 +0000
@@ -0,0 +1,191 @@
+# Copyright (c) 2018 - 2020  Peter Pentchev <roam@ringlet.net>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+"""A confget backend for reading INI-style files."""
+
+import io
+import re
+import sys
+
+from .. import defs
+
+from . import abstract
+
+try:
+    from typing import Callable, Dict, Match, NamedTuple, Pattern  # noqa: H301
+
+    _TYPING_USED = (defs, Dict)
+
+    MatcherType = NamedTuple(
+        "MatcherType",
+        [
+            ("regex", Pattern[str]),
+            (
+                "handle",
+                Callable[
+                    [Match[str], Dict[str, str], defs.Config, defs.ConfigData],
+                    None,
+                ],
+            ),
+        ],
+    )
+except ImportError:
+    import collections
+
+    MatcherType = collections.namedtuple(  # type: ignore
+        "MatcherType", ["regex", "handle"]
+    )
+
+
+class INIBackend(abstract.Backend):
+    # pylint: disable=too-few-public-methods
+    """Parse INI-style configuration files."""
+
+    def __init__(self, cfg, encoding="UTF-8"):
+        # type: (INIBackend, defs.Config, str) -> None
+        super(INIBackend, self).__init__(cfg)
+
+        if self._cfg.filename is None:
+            raise ValueError("No config filename specified")
+        if self._cfg.filename == "-":
+            infile = io.open(sys.stdin.fileno(), mode="r", encoding=encoding)
+        else:
+            infile = io.open(self._cfg.filename, mode="r", encoding=encoding)
+        self.infile = infile
+        self.parsed = {}  # type: defs.ConfigData
+
+    def read_file(self):
+        # type: (INIBackend) -> defs.ConfigData
+        state = {
+            "section": "",
+            "name": "",
+            "value": "",
+            "cont": "",
+            "found": "",
+        }
+        res = {"": {}}  # type: defs.ConfigData
+
+        def handle_section(
+            match,  # type: Match[str]
+            state,  # type: Dict[str, str]
+            cfg,  # type: defs.Config
+            res,  # type: defs.ConfigData
+        ):  # type: (...) -> None
+            """Handle a section heading: store the name."""
+            state["section"] = match.group("name")
+            if state["section"] not in res:
+                res[state["section"]] = {}
+            if not (cfg.section_specified or cfg.section or state["found"]):
+                cfg.section = state["section"]
+            state["found"] = state["section"]
+
+        def handle_comment(
+            _match,  # type: Match[str]
+            _state,  # type: Dict[str, str]
+            _cfg,  # type: defs.Config
+            _res,  # type: defs.ConfigData
+        ):  # type: (...) -> None
+            """Handle a comment line: ignore it."""
+            pass  # pylint: disable=unnecessary-pass
+
+        def handle_variable(
+            match,  # type: Match[str]
+            state,  # type: Dict[str, str]
+            _cfg,  # type: defs.Config
+            res,  # type: defs.ConfigData
+        ):  # type: (...) -> None
+            """Handle an assignment: store, check for a continuation."""
+            state["name"] = match.group("name")
+            state["value"] = match.group("value")
+            state["cont"] = match.group("cont")
+            state["found"] = state["name"]
+            if not state["cont"]:
+                res[state["section"]][state["name"]] = state["value"]
+
+        matches = [
+            MatcherType(
+                regex=re.compile(r"^ \s* (?: [#;] .* )? $", re.X),
+                handle=handle_comment,
+            ),
+            MatcherType(
+                regex=re.compile(
+                    r"""
+                    ^
+                    \s* \[ \s*
+                    (?P<name> [^\]]+? )
+                    \s* \] \s*
+                    $""",
+                    re.X,
+                ),
+                handle=handle_section,
+            ),
+            MatcherType(
+                regex=re.compile(
+                    r"""
+                    ^
+                    \s*
+                    (?P<name> [^\s=]+ )
+                    \s* = \s*
+                    (?P<value> .*? )
+                    \s*
+                    (?P<cont> [\\] )?
+                    $""",
+                    re.X,
+                ),
+                handle=handle_variable,
+            ),
+        ]
+
+        for line in self.infile.readlines():
+            line = line.rstrip("\r\n")
+            if state["cont"]:
+                if line.endswith("\\"):
+                    line, state["cont"] = line[:-1], line[-1]
+                else:
+                    state["cont"] = ""
+                state["value"] += line
+                if not state["cont"]:
+                    res[state["section"]][state["name"]] = state["value"]
+                continue
+
+            for data in matches:
+                match = data.regex.match(line)
+                if match is None:
+                    continue
+                data.handle(match, state, self._cfg, res)
+                break
+            else:
+                raise ValueError(
+                    "Unexpected line in {fname}: {line}".format(
+                        fname=self._cfg.filename, line=line
+                    )
+                )
+
+        self.parsed = res
+        return self.get_dict()
+
+    def get_dict(self):
+        # type: (INIBackend) -> defs.ConfigData
+        # no dict comprehension, this ought to work on Python 2.6, too
+        return dict((item[0], dict(item[1])) for item in self.parsed.items())
diff -pruN 2.3.3-1/python/src/confget/backend/__init__.py 2.3.4-1/python/src/confget/backend/__init__.py
--- 2.3.3-1/python/src/confget/backend/__init__.py	1970-01-01 00:00:00.000000000 +0000
+++ 2.3.4-1/python/src/confget/backend/__init__.py	2020-05-02 19:02:55.000000000 +0000
@@ -0,0 +1,42 @@
+# Copyright (c) 2018 - 2020  Peter Pentchev <roam@ringlet.net>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+"""Provide an interface to all the configuration format backends."""
+
+from . import abstract
+from . import http_get
+from . import ini
+
+try:
+    from typing import Dict, Type  # noqa: H301
+
+    _TYPING_USED = (Dict, Type, abstract)
+except ImportError:
+    pass
+
+
+BACKENDS = {
+    "http_get": http_get.HTTPGetBackend,
+    "ini": ini.INIBackend,
+}  # type: Dict[str, Type[abstract.Backend]]
diff -pruN 2.3.3-1/python/src/confget/defs.py 2.3.4-1/python/src/confget/defs.py
--- 2.3.3-1/python/src/confget/defs.py	1970-01-01 00:00:00.000000000 +0000
+++ 2.3.4-1/python/src/confget/defs.py	2020-05-02 19:02:55.000000000 +0000
@@ -0,0 +1,56 @@
+# Copyright (c) 2018 - 2020  Peter Pentchev <roam@ringlet.net>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+"""Common definitions for the confget configuration parsing library."""
+
+try:
+    from typing import Dict, List, Optional  # noqa: H301
+
+    _TYPING_USED = (List, Optional)
+
+    ConfigData = Dict[str, Dict[str, str]]
+except ImportError:
+    pass
+
+
+VERSION_STRING = "2.3.4"
+FEATURES = [("BASE", VERSION_STRING)]
+
+
+class Config(object):
+    # pylint: disable=too-few-public-methods
+    """Base class for the internal confget configuration."""
+
+    def __init__(
+        self,  # type: Config
+        varnames,  # type: List[str]
+        filename=None,  # type: Optional[str]
+        section="",  # type: str
+        section_specified=False,  # type: bool
+    ):  # type: (...) -> None
+        """Store the specified configuration values."""
+        self.filename = filename
+        self.section = section
+        self.section_specified = section_specified
+        self.varnames = varnames
diff -pruN 2.3.3-1/python/src/confget/format.py 2.3.4-1/python/src/confget/format.py
--- 2.3.3-1/python/src/confget/format.py	1970-01-01 00:00:00.000000000 +0000
+++ 2.3.4-1/python/src/confget/format.py	2020-05-02 19:02:55.000000000 +0000
@@ -0,0 +1,237 @@
+# Copyright (c) 2018 - 2020  Peter Pentchev <roam@ringlet.net>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+"""Filter and format a subset of the configuration variables."""
+
+import fnmatch
+import re
+
+try:
+    from typing import (
+        Callable,
+        Dict,
+        Iterable,
+        NamedTuple,
+        List,
+        Optional,
+    )  # noqa: H301
+
+    _TYPING_USED = (Callable, Dict, Iterable, List, Optional)
+
+    FormatOutput = NamedTuple(
+        "FormatOutput",
+        [
+            ("name", str),
+            ("value", str),
+            ("output_name", str),
+            ("output_value", str),
+            ("output_full", str),
+        ],
+    )
+except ImportError:
+    import collections
+
+    FormatOutput = collections.namedtuple(  # type: ignore
+        "FormatOutput",
+        ["name", "value", "output_name", "output_value", "output_full"],
+    )
+
+from . import defs
+
+
+class FormatConfig(defs.Config):
+    # pylint: disable=too-few-public-methods,too-many-instance-attributes
+    """Extend the config class with some output settings.
+
+    Add the following settings:
+    - list_all (boolean): list all variables, not just a subset
+    - match_regex (boolean): for match_var_names and match_var_values,
+      perform regular expression matches instead of filename pattern ones
+    - match_var_names (boolean): treat the variable names specified as
+      patterns and display all variables that match those
+    - match_var_values (string): display only the variables with values
+      that match this pattern
+    - name_prefix (string): when displaying variable names, prepend this string
+    - name_suffix (string): when displaying variable names, append this string
+    - show_var_name (boolean): display the variable names, not just
+      the values
+    - shell_escape (boolean): format the values in a manner suitable for
+      the Bourne shell
+    """
+
+    def __init__(
+        self,  # type: FormatConfig
+        varnames,  # type: List[str]
+        filename=None,  # type: Optional[str]
+        list_all=False,  # type: bool
+        match_regex=False,  # type: bool
+        match_var_names=False,  # type: bool
+        match_var_values=None,  # type: Optional[str]
+        name_prefix=None,  # type: Optional[str]
+        name_suffix=None,  # type: Optional[str]
+        section="",  # type: str
+        section_override=False,  # type: bool
+        section_specified=False,  # type: bool
+        show_var_name=False,  # type: bool
+        shell_escape=False,  # type: bool
+    ):  # type: (...) -> None
+        # pylint: disable=too-many-arguments
+        """Store the specified configuration values."""
+        super(FormatConfig, self).__init__(
+            filename=filename,
+            section=section,
+            section_specified=section_specified,
+            varnames=varnames,
+        )
+        self.list_all = list_all
+        self.match_regex = match_regex
+        self.match_var_names = match_var_names
+        self.match_var_values = match_var_values
+        self.name_prefix = name_prefix
+        self.name_suffix = name_suffix
+        self.section_override = section_override
+        self.shell_escape = shell_escape
+        self.show_var_name = show_var_name
+
+    def __repr__(self):
+        # type: (FormatConfig) -> str
+        return "{tname}({varnames}, {attrs})".format(
+            tname=type(self).__name__,
+            varnames=repr(self.varnames),
+            attrs=", ".join(
+                [
+                    "{name}={value}".format(
+                        name=name, value=repr(getattr(self, name))
+                    )
+                    for name in [
+                        "filename",
+                        "list_all",
+                        "match_regex",
+                        "match_var_names",
+                        "match_var_values",
+                        "name_prefix",
+                        "name_suffix",
+                        "section",
+                        "section_override",
+                        "section_specified",
+                        "show_var_name",
+                        "shell_escape",
+                    ]
+                ]
+            ),
+        )
+
+
+def get_check_function(cfg, patterns):
+    # type: (FormatConfig, List[str]) -> Callable[[str], bool]
+    """Get a predicate for displayed variables.
+
+    Get a function that determines whether a variable name should be
+    included in the displayed subset.
+    """
+    if cfg.match_regex:
+        re_vars = [re.compile(name) for name in patterns]
+
+        def check_re_vars(key):
+            # type: (str) -> bool
+            """Check that the key matches any of the specified regexes."""
+            return any(rex.search(key) for rex in re_vars)
+
+        return check_re_vars
+
+    def check_fn_vars(key):
+        # type: (str) -> bool
+        """Check that the key matches any of the specified patterns."""
+        return any(fnmatch.fnmatch(key, pattern) for pattern in patterns)
+
+    return check_fn_vars
+
+
+def get_varnames(cfg, sect_data):
+    # type: (FormatConfig, Dict[str, str]) -> Iterable[str]
+    """Get the variable names that match the configuration requirements."""
+    if cfg.list_all:
+        varnames = sect_data.keys()  # type: Iterable[str]
+    elif cfg.match_var_names:
+        check_var = get_check_function(cfg, cfg.varnames)
+        varnames = [name for name in sect_data.keys() if check_var(name)]
+    else:
+        varnames = [name for name in cfg.varnames if name in sect_data]
+
+    if not cfg.match_var_values:
+        return varnames
+
+    check_value = get_check_function(cfg, [cfg.match_var_values])
+    return [name for name in varnames if check_value(sect_data[name])]
+
+
+def filter_vars(cfg, data):
+    # type: (FormatConfig, defs.ConfigData) -> Iterable[FormatOutput]
+    """Filter the variables according to the specified criteria.
+
+    Return an iterable of FormatOutput structures allowing the caller to
+    process the variable names and values in various ways.
+    """
+    if cfg.section_override:
+        sect_data = data[""]
+    else:
+        sect_data = {}
+    if cfg.section in data:
+        sect_data.update(data[cfg.section])
+
+    varnames = get_varnames(cfg, sect_data)
+    res = []  # type: List[FormatOutput]
+    for name in sorted(varnames):
+        output_name = "{prefix}{name}{suffix}".format(
+            prefix="" if cfg.name_prefix is None else cfg.name_prefix,
+            name=name,
+            suffix="" if cfg.name_suffix is None else cfg.name_suffix,
+        )
+
+        value = sect_data[name]
+        if cfg.shell_escape:
+            output_value = "'{esc}'".format(
+                esc="'\"'\"'".join(value.split("'"))
+            )
+        else:
+            output_value = value
+
+        if cfg.show_var_name:
+            output_full = "{name}={value}".format(
+                name=output_name, value=output_value
+            )
+        else:
+            output_full = output_value
+
+        res.append(
+            FormatOutput(
+                name=name,
+                value=value,
+                output_name=output_name,
+                output_value=output_value,
+                output_full=output_full,
+            )
+        )
+
+    return res
diff -pruN 2.3.3-1/python/src/confget/__init__.py 2.3.4-1/python/src/confget/__init__.py
--- 2.3.3-1/python/src/confget/__init__.py	1970-01-01 00:00:00.000000000 +0000
+++ 2.3.4-1/python/src/confget/__init__.py	2020-05-02 19:02:55.000000000 +0000
@@ -0,0 +1,108 @@
+# Copyright (c) 2019, 2020  Peter Pentchev <roam@ringlet.net>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+"""confget - a library for parsing configuration files
+
+The `confget` library parses configuration files (currently INI-style
+files and CGI `QUERY_STRING` environment variable) and allows a program
+to use the values defined in them.  It provides various options for
+selecting the variable names and values to return and the configuration
+file sections to fetch them from.
+
+The `confget` library may also be used as a command-line tool with
+the same interface as the C implementation.
+
+The `confget` library is fully typed.
+
+Specifying configuration values for the backends
+------------------------------------------------
+
+The `confget.defs` module defines the `Config` class that is used to
+control the behavior of the various `confget` backends.  Its main
+purpose is to specify the filename and, optionally, the section name for
+INI-style files, but other backends may use its fields in different ways.
+
+A `Config` object is created using the following parameters:
+- a list of variable names to query (may be empty)
+- `filename` (str, optional): the name of the file to open
+- `section` (str, default ""): the name of the section within the file
+- `section_specified` (bool, default false): if `section` is an empty
+  string, only fetch variables from the unnamed section at the start of
+  the file instead of defaulting to the first section in the file
+
+Parsing INI-style configuration files
+-------------------------------------
+
+The `confget` library's "ini" backend parses an INI-style configuration
+file.  Its `read_file()` method parses the file and returns a dictionary
+of sections and the variables and their values within them:
+
+    import confget
+
+    cfg = confget.Config([], filename='config.ini')
+    ini = confget.BACKENDS['ini'](cfg)
+    data = ini.read_file()
+    print('Section names: {names}'.format(names=sorted(data.keys())))
+    print(data['server']['address'])
+
+Letting variables in a section override the default ones
+--------------------------------------------------------
+
+In some cases it is useful to have default values before the first
+named section in a file and then override some values in various
+sections.  This may be useful for e.g. host-specific configuration
+kept in a section with the same name as the host.
+
+The `format` module in the `confget` library allows, among other
+filtering modes, to get the list of variables with a section
+overriding the default ones:
+
+    from confget import backend, format
+
+    cfg = format.FormatConfig(['foo'], filename='config.ini', section='first',
+                              section_override=True)
+    ini = backend.BACKENDS['ini'](cfg)
+    data = ini.read_file()
+    res = format.filter_vars(cfg, data)
+    assert len(res) == 1, repr(res)
+    print(res[0].output_full)
+
+    cfg = format.FormatConfig(['foo'], filename='config.ini', section='second',
+                              section_override=True)
+    ini = backend.BACKENDS['ini'](cfg)
+    data = ini.read_file()
+    res = format.filter_vars(cfg, data)
+    assert len(res) == 1, repr(res)
+    print(res[0].output_full)
+
+See the documentation of the `FormatConfig` class and the `filter_vars()`
+function in the `confget.format` module for more information and for
+a list of the various other filtering modes, all supported when
+the library is used as a command-line tool.
+"""
+
+from .defs import Config, VERSION_STRING  # noqa: H301
+from .backend import BACKENDS
+
+__all__ = ("BACKENDS", "Config", "VERSION_STRING")
diff -pruN 2.3.3-1/python/src/confget/__main__.py 2.3.4-1/python/src/confget/__main__.py
--- 2.3.3-1/python/src/confget/__main__.py	1970-01-01 00:00:00.000000000 +0000
+++ 2.3.4-1/python/src/confget/__main__.py	2020-05-02 19:02:55.000000000 +0000
@@ -0,0 +1,387 @@
+# Copyright (c) 2018 - 2020  Peter Pentchev
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+"""The command-line interface to the confget module: specify some parameters
+through command-line options, then display variable values or names.
+"""
+
+from __future__ import print_function
+
+import argparse
+import sys
+
+from . import backend
+from . import defs
+from . import format as fmt
+from .backend import abstract
+
+try:
+    from typing import List, Optional, Tuple, Type  # noqa: H301
+
+    _TYPING_USED = (defs, List, Optional)
+except ImportError:
+    pass
+
+
+class MainConfig(fmt.FormatConfig):
+    # pylint: disable=too-few-public-methods,too-many-instance-attributes
+    """Extend the format config class with some output settings.
+
+    Add the following settings:
+    - check_only (boolean): only check whether a variable is defined
+    - query_sections (boolean): only display the section names
+    """
+
+    def __init__(
+        self,  # type: MainConfig
+        check_only,  # type: bool
+        filename,  # type: Optional[str]
+        list_all,  # type: bool
+        match_regex,  # type: bool
+        match_var_names,  # type: bool
+        match_var_values,  # type: Optional[str]
+        name_prefix,  # type: Optional[str]
+        name_suffix,  # type: Optional[str]
+        query_sections,  # type: bool
+        section,  # type: str
+        section_override,  # type: bool
+        section_specified,  # type: bool
+        show_var_name,  # type: bool
+        shell_escape,  # type: bool
+        varnames,  # type: List[str]
+    ):  # type: (...) -> None
+        # pylint: disable=too-many-arguments,too-many-locals
+        """Store the specified configuration values."""
+        super(MainConfig, self).__init__(
+            filename=filename,
+            list_all=list_all,
+            match_regex=match_regex,
+            match_var_names=match_var_names,
+            match_var_values=match_var_values,
+            name_prefix=name_prefix,
+            name_suffix=name_suffix,
+            section=section,
+            section_specified=section_specified,
+            section_override=section_override,
+            show_var_name=show_var_name,
+            shell_escape=shell_escape,
+            varnames=varnames,
+        )
+        self.check_only = check_only
+        self.query_sections = query_sections
+
+
+def version():
+    # type: () -> None
+    """Display program version information."""
+    print("confget " + defs.VERSION_STRING)
+
+
+def features(name):
+    # type: (Optional[str]) -> None
+    """Display a list of the features supported by the program."""
+    if name is None:
+        print(
+            " ".join(
+                [
+                    "{name}={version}".format(name=item[0], version=item[1])
+                    for item in defs.FEATURES
+                ]
+            )
+        )
+    else:
+        ver = dict(defs.FEATURES).get(name, None)
+        if ver is None:
+            sys.exit(1)
+        print(ver)
+
+
+def output_check_only(cfg, data):
+    # type: (MainConfig, defs.ConfigData) -> None
+    """Check whether the variable is present."""
+    if cfg.section not in data:
+        sys.exit(1)
+    elif cfg.varnames[0] not in data[cfg.section]:
+        sys.exit(1)
+    sys.exit(0)
+
+
+def output_vars(cfg, data):
+    # type: (MainConfig, defs.ConfigData) -> None
+    """Output the variable values."""
+    for vitem in fmt.filter_vars(cfg, data):
+        print(vitem.output_full)
+
+
+def output_sections(data):
+    # type: (defs.ConfigData) -> None
+    """Output the section names."""
+    for name in sorted(data.keys()):
+        if name != "":
+            print(name)
+
+
+def validate_options(args, backend_name):
+    # type: (argparse.Namespace, str) -> None
+    """Detect invalid combinations of command-line options."""
+    query_sections = args.query == "sections"
+
+    if args.list_all or query_sections:
+        if args.varnames:
+            sys.exit("Only a single query at a time, please!")
+    elif args.match_var_names:
+        if not args.varnames:
+            sys.exit("No patterns to match against")
+    elif args.check_only and len(args.varnames) > 1:
+        sys.exit("Only a single query at a time, please!")
+    elif not args.varnames:
+        sys.exit("No variables specified to query")
+
+    if query_sections and backend_name != "ini":
+        sys.exit(
+            "The query for sections is only supported for "
+            "the 'ini' backend for the present"
+        )
+
+
+def check_option_conflicts(args):
+    # type: (argparse.Namespace) -> None
+    """Make sure that the command-line options do not conflict."""
+    total = (
+        int(args.query is not None)
+        + int(args.match_var_names)
+        + int(args.list_all)
+        + int(
+            bool(args.varnames)
+            and not (args.match_var_names or args.query == "feature")
+        )
+    )
+    if total > 1:
+        sys.exit("Only a single query at a time, please!")
+
+
+def parse_args():
+    # type: () -> Tuple[MainConfig, Type[abstract.Backend]]
+    """Parse the command-line arguments."""
+    parser = argparse.ArgumentParser(
+        prog="confget",
+        usage="""
+    confget [-t ini] -f filename [-s section] varname...
+    confget -V | -h | --help | --version
+    confget -q features""",
+    )
+    parser.add_argument(
+        "-c",
+        action="store_true",
+        dest="check_only",
+        help="check whether the variables are defined in " "the file",
+    )
+    parser.add_argument(
+        "-f",
+        type=str,
+        dest="filename",
+        help="specify the configuration file name",
+    )
+    parser.add_argument(
+        "-L",
+        action="store_true",
+        dest="match_var_names",
+        help="specify which variables to display",
+    )
+    parser.add_argument(
+        "-l",
+        action="store_true",
+        dest="list_all",
+        help="list all variables in the specified section",
+    )
+    parser.add_argument(
+        "-m",
+        type=str,
+        dest="match_var_values",
+        help="only display variables with values that match "
+        "the specified pattern",
+    )
+    parser.add_argument(
+        "-N",
+        action="store_true",
+        dest="show_var_name",
+        help="always display the variable name",
+    )
+    parser.add_argument(
+        "-n",
+        action="store_true",
+        dest="hide_var_name",
+        help="never display the variable name",
+    )
+    parser.add_argument(
+        "-O",
+        action="store_true",
+        dest="section_override",
+        help="allow variables in the specified section to "
+        "override those placed before any "
+        "section definitions",
+    )
+    parser.add_argument(
+        "-P",
+        type=str,
+        dest="name_suffix",
+        help="display this string after the variable name",
+    )
+    parser.add_argument(
+        "-p",
+        type=str,
+        dest="name_prefix",
+        help="display this string before the variable name",
+    )
+    parser.add_argument(
+        "-q",
+        type=str,
+        dest="query",
+        choices=["feature", "features", "sections"],
+        help="query for a specific type of information, e.g. the list of "
+        "sections defined in "
+        "the configuration file",
+    )
+    parser.add_argument(
+        "-S",
+        action="store_true",
+        dest="shell_quote",
+        help="quote the values suitably for the Bourne shell",
+    )
+    parser.add_argument(
+        "-s",
+        type=str,
+        dest="section",
+        help="specify the configuration file section",
+    )
+    parser.add_argument(
+        "-t",
+        type=str,
+        default="ini",
+        dest="backend",
+        help="specify the configuration file type",
+    )
+    parser.add_argument(
+        "-V",
+        "--version",
+        action="store_true",
+        help="display program version information and exit",
+    )
+    parser.add_argument(
+        "-x",
+        action="store_true",
+        dest="match_regex",
+        help="treat the match patterns as regular expressions",
+    )
+    parser.add_argument(
+        "varnames", nargs="*", help="the variable names to query"
+    )
+
+    args = parser.parse_args()
+    if args.version:
+        version()
+        sys.exit(0)
+
+    check_option_conflicts(args)
+
+    if args.query == "features":
+        if args.varnames:
+            sys.exit("No arguments to -q features")
+        features(None)
+        sys.exit(0)
+    if args.query == "feature":
+        if len(args.varnames) != 1:
+            sys.exit("Only a single feature name expected")
+        features(args.varnames[0])
+        sys.exit(0)
+
+    query_sections = args.query == "sections"
+
+    cfg = MainConfig(
+        check_only=args.check_only,
+        filename=args.filename,
+        list_all=args.list_all,
+        match_regex=args.match_regex,
+        match_var_names=args.match_var_names,
+        match_var_values=args.match_var_values,
+        name_prefix=args.name_prefix,
+        name_suffix=args.name_suffix,
+        query_sections=query_sections,
+        section=args.section if args.section is not None else "",
+        section_override=args.section_override,
+        section_specified=args.section is not None,
+        shell_escape=args.shell_quote,
+        show_var_name=args.show_var_name
+        or (
+            (args.match_var_names or args.list_all or len(args.varnames) > 1)
+            and not args.hide_var_name
+        ),
+        varnames=args.varnames,
+    )
+
+    matched_backends = [
+        name
+        for name in sorted(backend.BACKENDS.keys())
+        if name.startswith(args.backend)
+    ]
+    if not matched_backends:
+        sys.exit(
+            'Unknown backend "{name}", use "list" for a list'.format(
+                name=args.backend
+            )
+        )
+    elif len(matched_backends) > 1:
+        sys.exit(
+            'Ambiguous backend "{name}": {lst}'.format(
+                name=args.backend, lst=" ".join(matched_backends)
+            )
+        )
+    back = backend.BACKENDS[matched_backends[0]]
+
+    validate_options(args, matched_backends[0])
+
+    return cfg, back
+
+
+def main():
+    # type: () -> None
+    """The main program: parse arguments, do things."""
+    cfg, back = parse_args()
+
+    try:
+        cfgp = back(cfg)
+    except Exception as exc:  # pylint: disable=broad-except
+        sys.exit(str(exc))
+    data = cfgp.read_file()
+
+    if cfg.check_only:
+        output_check_only(cfg, data)
+    elif cfg.query_sections:
+        output_sections(data)
+    else:
+        output_vars(cfg, data)
+
+
+if __name__ == "__main__":
+    main()
diff -pruN 2.3.3-1/python/test_data/defs/tests/01-get-values.json 2.3.4-1/python/test_data/defs/tests/01-get-values.json
--- 2.3.3-1/python/test_data/defs/tests/01-get-values.json	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/python/test_data/defs/tests/01-get-values.json	2020-05-02 19:02:55.000000000 +0000
@@ -288,6 +288,22 @@
       },
       "setenv": true,
       "stdin": null
+    },
+    {
+      "args": {
+        "filename": "t4.ini",
+        "section": "x"
+      },
+      "keys": [
+        "key8"
+      ],
+      "xform": "",
+      "backend": "ini",
+      "output": {
+        "exact": "key9=key10=key11"
+      },
+      "setenv": false,
+      "stdin": null
     }
   ]
 }
diff -pruN 2.3.3-1/python/test_data/t4.ini 2.3.4-1/python/test_data/t4.ini
--- 2.3.3-1/python/test_data/t4.ini	1970-01-01 00:00:00.000000000 +0000
+++ 2.3.4-1/python/test_data/t4.ini	2020-05-02 19:02:55.000000000 +0000
@@ -0,0 +1,16 @@
+# Just a test file.  Or something.
+# This file is hereby placed into the public domain.
+#
+# Test if confget can properly override "default" values with
+# ones specified in a named section.
+
+both=default
+defonly=default
+
+[a]
+aonly=b
+both=a
+aonly=a
+
+[x]
+key8=key9=key10=key11
diff -pruN 2.3.3-1/python/tox.ini 2.3.4-1/python/tox.ini
--- 2.3.3-1/python/tox.ini	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/python/tox.ini	2020-05-02 19:02:55.000000000 +0000
@@ -29,7 +29,7 @@ envlist = pep8,mypy2,mypy3,unit_tests_2,
 envlist_devel = {[tox]envlist},prove_2,prove_2_nt,prove_3,pep8h
 
 pyfiles_default =
-  confget
+  src/confget
   setup.py
   unit_tests
 
@@ -40,7 +40,7 @@ pyfiles_devel =
 pyfiles = {[defs]pyfiles_{env:CONFGET_TOX_MODE:default}}
 
 mypy_files_nodec_2 =
-  confget
+  src/confget
   setup.py
 
 mypy_files_nodec_3_extra_default =
@@ -81,7 +81,7 @@ skip_install = True
 deps =
   mypy
 setenv =
-  MYPYPATH={toxinidir}/stubs/2
+  MYPYPATH={toxinidir}/stubs/2:{toxinidir}/src
 commands =
   mypy --strict --py2 {[defs]mypy_files_nodec_2}
   mypy --strict --py2 --allow-untyped-decorators {[defs]mypy_files_dec}
@@ -91,6 +91,8 @@ basepython = python3
 skip_install = True
 deps =
   mypy
+setenv =
+  MYPYPATH={toxinidir}/src
 commands =
   mypy --strict {[defs]mypy_files_nodec_3}
   mypy --strict --allow-untyped-decorators {[defs]mypy_files_dec}
@@ -140,7 +142,7 @@ deps =
 whitelist_externals =
   sh
 commands =
-  sh -c 'cd ../t && env PYTHONPATH={toxinidir} python defs/tools/generate.py'
+  sh -c 'cd ../t && env PYTHONPATH={toxinidir}:{toxinidir}/src python defs/tools/generate.py'
 
 [testenv:prove_2]
 basepython = python2
diff -pruN 2.3.3-1/t/01-get-values.t 2.3.4-1/t/01-get-values.t
--- 2.3.3-1/t/01-get-values.t	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/t/01-get-values.t	2020-05-02 19:02:55.000000000 +0000
@@ -27,13 +27,18 @@
 [ -z "$CONFGET" ] && CONFGET='./confget'
 [ -z "$TESTDIR" ] && TESTDIR='t'
 
-echo '1..18'
+echo '1..19'
 
 
 if [ ! -f "$TESTDIR/t1.ini" ]; then
         echo "Bail out!  No test file $TESTDIR/t1.ini"
         exit 255
 fi
+
+if [ ! -f "$TESTDIR/t4.ini" ]; then
+        echo "Bail out!  No test file $TESTDIR/t4.ini"
+        exit 255
+fi
 v=`$CONFGET '-f' "$TESTDIR/t1.ini" '-s' 'a' 'key1' `
 res="$?"
 if [ "$v" = 'value1' ]; then echo 'ok 1'; else echo "not ok 1 v is '$v'"; fi
@@ -88,3 +93,6 @@ if [ "$v" = '' ]; then echo 'ok 17'; els
 v=`env Q1='key4&amp;key5=%09%09%20val%27ue5&key6' Q2='' QUERY_STRING='key1=value1&key2=%3Dvalue2%26&amp;key3=%09%09%20val%27ue3' $CONFGET -t http_get '-s' 'Q2' 'key66' `
 res="$?"
 if [ "$v" = '' ]; then echo 'ok 18'; else echo "not ok 18 v is '$v'"; fi
+v=`$CONFGET '-f' "$TESTDIR/t4.ini" '-s' 'x' 'key8' `
+res="$?"
+if [ "$v" = 'key9=key10=key11' ]; then echo 'ok 19'; else echo "not ok 19 v is '$v'"; fi
diff -pruN 2.3.3-1/t/08-bespoke-shell-quote.t 2.3.4-1/t/08-bespoke-shell-quote.t
--- 2.3.3-1/t/08-bespoke-shell-quote.t	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/t/08-bespoke-shell-quote.t	2020-05-02 19:02:55.000000000 +0000
@@ -1,6 +1,6 @@
 #!/bin/sh
 #
-# Copyright (c) 2008  Peter Pentchev
+# Copyright (c) 2008, 2020  Peter Pentchev
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
@@ -29,7 +29,7 @@
 
 T1="$TESTDIR/t1.ini"
 
-echo '1..6'
+echo '1..7'
 
 if [ ! -f "$T1" ]; then
 	echo "Bail out!  No test file $T1"
@@ -47,3 +47,7 @@ if [ "$cfg_key1" = 'value1' ]; then echo
 if [ "$cfg_key2" = 'value2' ]; then echo 'ok 4'; else echo "not ok 4 cfg_key2 is '$cfg_key2'"; fi
 if [ "$cfg_key3" = " val'ue3" ]; then echo 'ok 5'; else echo "not ok 5 cfg_key3 is '$cfg_key3'"; fi
 if [ "$cfg_key6" = 'value6' ]; then echo 'ok 6'; else echo "not ok 6 cfg_key6 is '$cfg_key6'"; fi
+
+unset cfg_key1_value
+eval `$CONFGET -f "$T1" -S -p cfg_ -P _value -s a -N key1`
+if [ "$cfg_key1_value" = 'value1' ]; then echo 'ok 7'; else echo "not ok 7 cfg_key1_value is '$cfg_key1_value'"; fi
diff -pruN 2.3.3-1/t/defs/tests/01-get-values.json 2.3.4-1/t/defs/tests/01-get-values.json
--- 2.3.3-1/t/defs/tests/01-get-values.json	2020-04-07 13:39:43.000000000 +0000
+++ 2.3.4-1/t/defs/tests/01-get-values.json	2020-05-02 19:02:55.000000000 +0000
@@ -288,6 +288,22 @@
       },
       "setenv": true,
       "stdin": null
+    },
+    {
+      "args": {
+        "filename": "t4.ini",
+        "section": "x"
+      },
+      "keys": [
+        "key8"
+      ],
+      "xform": "",
+      "backend": "ini",
+      "output": {
+        "exact": "key9=key10=key11"
+      },
+      "setenv": false,
+      "stdin": null
     }
   ]
 }
diff -pruN 2.3.3-1/t/t4.ini 2.3.4-1/t/t4.ini
--- 2.3.3-1/t/t4.ini	1970-01-01 00:00:00.000000000 +0000
+++ 2.3.4-1/t/t4.ini	2020-05-02 19:02:55.000000000 +0000
@@ -0,0 +1,16 @@
+# Just a test file.  Or something.
+# This file is hereby placed into the public domain.
+#
+# Test if confget can properly override "default" values with
+# ones specified in a named section.
+
+both=default
+defonly=default
+
+[a]
+aonly=b
+both=a
+aonly=a
+
+[x]
+key8=key9=key10=key11
